public class EvaluateVisitor implements Visitor
{
   private Stack<Double> stack;

   public EvaluateVisitor()
   {
      stack = new Stack<>(1000);
   }

   public double total()
   {
      try
      {
         return stack.peek();
      }
      catch (StackEmptyException see)
      {
         return 0.0;
      }
   }

   @Override
   public void visitAddNode(AddNode n)
   {
      try
      {
         n.left.accept(this);
         n.right.accept(this);
         stack.push(stack.pop()+stack.pop());
      }
      catch (StackFullException | StackEmptyException sfee)
      {
         sfee.printStackTrace();
      }
   }

   @Override
   public void visitDivNode(DivNode n)
   {
      try
      {
         n.left.accept(this);
         n.right.accept(this);
         double rhs = stack.pop();
         stack.push(stack.pop()/rhs);
      }
      catch (StackFullException | StackEmptyException sfee)
      {
         sfee.printStackTrace();
      }
   }

   @Override
   public void visitMulNode(MulNode n)
   {
      try
      {
         n.left.accept(this);
         n.right.accept(this);
         stack.push(stack.pop()*stack.pop());
      }
      catch (StackFullException | StackEmptyException sfee)
      {
         sfee.printStackTrace();
      }
   }

   @Override
   public void visitNegNode(NegNode n)
   {
      try
      {
         n.left.accept(this);
         stack.push(-stack.pop());
      }
      catch (StackFullException | StackEmptyException sfee)
      {
         sfee.printStackTrace();
      }
   }

   @Override
   public void visitNumNode(NumNode n)
   {
      try
      {
         stack.push(n.value);
      }
      catch (StackFullException sfe)
      {
         sfe.printStackTrace();
      }
   }

   @Override
   public void visitSubNode(SubNode n)
   {
      try
      {
         n.left.accept(this);
         n.right.accept(this);
         double rhs = stack.pop();
         stack.push(stack.pop()-rhs);
      }
      catch (StackFullException | StackEmptyException sfee)
      {
         sfee.printStackTrace();
      }
   }
}